unit emulator;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, RS232_Handle, ExtCtrls, Menus;

type
  TDummy = array [0..$1F] of byte;
  Treading = (LSB, MSB);
  TMPLABstyle = (syByte, syBit, syAll); 
  TPhoneForm = class(TForm)
    ReadBtn: TButton;
    WriteBtn: TButton;
    Mem: TStringGrid;
    proc: TMemo;
    ConnectBtn: TButton;
    RSTBtn: TButton;
    Indik: TLabel;
    Busy: TTimer;
    RateScroll: TScrollBar;
    comLab: TLabel;
    ExitLab: TLabel;
    comPop: TPopupMenu;
    COM11: TMenuItem;
    COM202F81: TMenuItem;
    COM303E81: TMenuItem;
    COM402E81: TMenuItem;
    saveBtn: TButton;
    SaveDlg: TSaveDialog;
    BinaryBtn: TButton;
    msb_lsb_lab: TLabel;
    msbLsbPop: TPopupMenu;
    b0MSB: TMenuItem;
    bit0LSB: TMenuItem;
    SavePop: TPopupMenu;
    saveHEX1: TMenuItem;
    saveMPLABbyte: TMenuItem;
    saveBinary1: TMenuItem;
    saveMPLABbits: TMenuItem;
    HackresetCheck: TCheckBox;
    Del_Unit_pop: TPopupMenu;
    Delete_auto: TMenuItem;
    Deleteposition1: TMenuItem;
    procedure ConnectBtnClick(Sender: TObject);
    procedure BusyTimer(Sender: TObject);
    procedure ReadBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RSTBtnClick(Sender: TObject);
    procedure ExitLabClick(Sender: TObject);
    procedure COM11Click(Sender: TObject);
    procedure COM202F81Click(Sender: TObject);
    procedure COM303E81Click(Sender: TObject);
    procedure COM402E81Click(Sender: TObject);
    procedure comLabClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure BinaryBtnClick(Sender: TObject);
    procedure msb_lsb_labClick(Sender: TObject);
    procedure b0MSBClick(Sender: TObject);
    procedure bit0LSBClick(Sender: TObject);
    procedure saveHEX1Click(Sender: TObject);
    procedure saveMPLABbyteClick(Sender: TObject);
    procedure saveMPLABbitsClick(Sender: TObject);
    procedure saveBinary1Click(Sender: TObject);
    procedure Delete_autoClick(Sender: TObject);
    procedure Deleteposition1Click(Sender: TObject);
    procedure WriteBtnClick(Sender: TObject);
  private
    { Private declarations }
    quit: boolean;
    procedure CardReset;
    procedure hackReset;
    procedure Wait;
    procedure WriteBit;
    procedure DeletePosition(p: byte);
    procedure DeleteUnit;
    procedure SetCardPtr;
  public
    { Public declarations }
  end;

var
  PhoneForm: TPhoneForm;
  Dummy: TDummy;
  reading: TReading;
  mp_lab_style: TMPLABstyle;
  u_pos: boolean;

implementation

uses binary;

{$R *.DFM}

procedure TPhoneForm.ConnectBtnClick(Sender: TObject);
begin
  u_pos:= false;
  PBA:= COM2;
  Write_TxD(true);
  Proc.Lines.Add('Charging the condenser');
  Busy.enabled:= true;
  repeat
    Application.ProcessMessages;
  until Scan_CTS(PBA) or quit;
  if Scan_CTS(PBA) then Proc.Lines.Add('Supply Voltage OK!  - interface connected - ');
  Busy.enabled:= false;
  Indik.Color:= clBtnFace;
end;

procedure TPhoneForm.BusyTimer(Sender: TObject);
begin
  case Indik.Color of
    clBtnFace: Indik.Color:= clRed;
    clRed: Indik.Color:= clBtnFace;
  end;
end;

procedure TPhoneForm.Wait;
var
  i: cardinal;
begin;
  for i:=0 to (RateScroll.Position * 10000) do
end;

procedure TPhoneForm.CardReset;
begin
  Write_RTS(false);
  Write_TxD(false);
  Write_DTR(false);
  Wait;
  Write_RTS(true);
  Wait;
  Wait;
  Write_RTS(false);
  Wait;
  Write_TxD(true);
end;

procedure TPhoneForm.hackReset;
begin
  Write_RTS(false);
  Write_TxD(true);
  Write_DTR(false);
  Wait;
  Write_RTS(true);
  Wait;
  Wait;
  Write_TxD(false);
  Wait;
  Wait;
  Write_TxD(true);
  Write_RTS(false);
  Wait;
  Write_TxD(true);
end;

procedure TPhoneForm.ReadBtnClick(Sender: TObject);
var i, j, value: byte;
    l: integer;
    inbit: boolean;
    binarystr: string;
begin
  u_pos:= false;
  BinaryForm.BinMem.Clear;
  BinaryForm.BinMem.Lines.Add('binary card data...');
  case reading of
    LSB: begin
           BinaryForm.BinMem.Lines.Add('bit 0 (in card) as LSM');
           BinaryForm.BinMem.Lines.Add('bits: 76543210..76... (in card)');
         end;
    MSB: begin
           BinaryForm.BinMem.Lines.Add('bit 0 (in card) as MSB');
           BinaryForm.BinMem.Lines.Add('bits: 01234567..01... (in card)');;
         end;
  end;
  BinaryForm.BinMem.Lines.Add('bits: 76543210 (in byte)');
  BinaryForm.BinMem.Lines.Add('');
  for i:= 0 to $1F do
    dummy[i]:= $00;
  Proc.Lines.Add('Resetting Card...');
  Proc.Lines.Add('Reading data...');
  Proc.Lines.Add('****');
  l:= Proc.Lines.Count;
  Write_DTR(false);
  Write_RTS(false);
  busy.enabled:= true;
  case hackResetCheck.Checked of
    true: hackReset;
    false: CardReset;
  end;
  for i:=0 to $1F do begin
    Proc.Lines[l-1]:='PROCESS: ' + IntToStr((i+1)*8)+ ' bits';
    {ptr:= i div 8;}
    value:= 0;
    binarystr:= '';
    for j:=0 to 7 do begin
      case reading of
        LSB: begin
               value:= value shr 1;
               inbit:= Scan_DSR(PBA);
               if inbit then value:= value or $80;
               binarystr:= IntToStr(byte(inbit)) + binarystr;
             end;
        MSB: begin
               value:= value shl 1;
               inbit:= Scan_DSR(PBA);
               if inbit then inc(value);
               binarystr:= binarystr + IntToStr(byte(inbit));
             end;
      end;
      {CLK___---____}
      Write_RTS(false);
      Wait;
      Write_RTS(true);
      Wait;Wait;
      Wait;
      Write_RTS(false);
      Wait;
      Wait;Wait;
    end;
    Dummy[i]:= value;
    application.ProcessMessages;

    if i <10 then
      binaryStr:= ' ' + IntToStr(i)+ '>   ' + binaryStr
    else
      binaryStr:= IntToStr(i)+ '>   ' + binarystr;
    BinaryForm.BinMem.Lines.Add(binarystr);
  end;
  for i:=0 to $1F do
    mem.Cells[(i mod $8)+1, (i div $8)+1]:= IntToHex(dummy[i], 2);
  busy.enabled:= false;
  Indik.Color:= clBtnFace;
  Proc.Lines.Add('Done...');
end;

procedure TPhoneForm.FormCreate(Sender: TObject);
var i: byte;
begin
  for i:= 0 to $1F do begin
    mem.cells[(i mod 8)+1, (i div 8)+1]:= '00';
    dummy[i]:= $00;
  end;
  for i:= 0 to 7 do
    mem.cells[i+1, 0]:= IntToHex(i, 2);
  for i:= 0 to 4 do
    mem.cells[0, i+1]:= IntToHex(i div 2, 2);
  reading:= MSB;
end;

procedure TPhoneForm.RSTBtnClick(Sender: TObject);
begin
  u_pos:= false;
  Proc.Lines.Add('Disconnecting...');
  Write_RTS(false);
  Write_TxD(false);
  Write_DTR(false);
  repeat
    application.processmessages;
  until not Scan_CTS(PBA) or quit;
  if not Scan_CTS(PBA) then Proc.Lines.Add('Power down... OFF, choose connect for reconect...');
end;

procedure TPhoneForm.ExitLabClick(Sender: TObject);
begin
  quit:= true;
  Close;
end;

procedure TPhoneForm.COM11Click(Sender: TObject);
begin
  PBA:= COM1;
  comLab.caption:= 'COM1';
end;

procedure TPhoneForm.COM202F81Click(Sender: TObject);
begin
  PBA:= COM2;
  comLab.caption:= 'COM2';
end;

procedure TPhoneForm.COM303E81Click(Sender: TObject);
begin
  PBA:= COM3;
  comLab.caption:= 'COM3';
end;

procedure TPhoneForm.COM402E81Click(Sender: TObject);
begin
  PBA:= COM4;
  comLab.caption:= 'COM4';
end;

procedure TPhoneForm.comLabClick(Sender: TObject);
begin
  comPop.popup(comlab.left +10+ phoneform.left ,comlab.top+20+ phoneform.top);
end;

procedure TPhoneForm.saveBtnClick(Sender: TObject);
begin
  mp_lab_style:= syByte;
  savePop.popup(saveBtn.left +10+ phoneform.left ,saveBtn.top+20+ phoneform.top);
end;

procedure TPhoneForm.BinaryBtnClick(Sender: TObject);
begin
  BinaryForm.Show;
end;

procedure TPhoneForm.msb_lsb_labClick(Sender: TObject);
begin
  msbLsbPop.popup(msb_lsb_lab.left +20+ phoneform.left ,msb_lsb_lab.top+40+ phoneform.top);
end;

procedure TPhoneForm.b0MSBClick(Sender: TObject);
begin
  reading:= MSB;
  msb_lsb_lab.caption:= 'bit 0: MSB';
end;

procedure TPhoneForm.bit0LSBClick(Sender: TObject);
begin
  reading:= LSB;
  msb_lsb_lab.caption:= 'bit 0: LSB';
end;

procedure TPhoneForm.saveHEX1Click(Sender: TObject);
var destf: textfile;
    i, ii: byte;
begin
  if SaveDlg.Execute then begin
    AssignFile(destf, SaveDlg.FileName);
    Rewrite(destf);
    try
      Writeln(destf, '> Created by Phone Card Emulator v1.0, developed by Cyber, Peter Sladek <');
      Writeln(destf, 'WEB: http://asyncbrain.baf.cz');
      Writeln(destf, 'designed for ST2000 phone cards...');
      Writeln(destf, '~');
      Writeln(destf, 'vypis obsahu pameti telefonii karticky: (hex)');
      Writeln(destf, '');
      case reading of
        LSB: begin
               Writeln(destf, 'bit 0 as LSB - byte reading:');
               Writeln(destf, 'bit out: 0-> 1-> 2-> 3-> 4-> 5-> 6-> 7 ->8 ->9... bit-reading sequence');
               Writeln(destf, 'bit #:   0   1   2   3   4   5   6   7   0   1');
             end;
        MSB: begin
               Writeln(destf, 'bit 0 as MSB - byte reading:');
               Writeln(destf, 'bit out: 0-> 1-> 2-> 3-> 4-> 5-> 6-> 7 ->8 ->9... bit-reading sequence');
               Writeln(destf, 'bit #:   7   6   5   4   3   2   1   0   7   6');
             end;
      end;
      Writeln(destf,'');
      Writeln(destf,'');
      Write(destf, '    ');
      for i:= 0 to $F do
        Write(destf, '  ' + IntToHex(i, 2));
      Writeln(destf, '');
      for ii:= 0 to 1 do begin
        Writeln(destf, '');
        Write(destf, IntToHex(ii, 2) + '  ');
        for i:= 0 to $F do
           Write(destf, '  ' + IntToHex(Dummy[i+(ii*$10)], 2));
      end;
      Writeln(destf, ' ');
      Writeln(destf, '>');
      Writeln(destf, 'good luck... at your work :-)))');
      Writeln(destf, 'no, interface je slozitejsi, ale za to bezpecnejsi.. pro kamarada menem PC');
    finally
      CloseFile(destf);
    end;
  end;
end;

procedure TPhoneForm.saveMPLABbyteClick(Sender: TObject);
var destf: textfile;
    i: byte;
begin
  if SaveDlg.Execute then begin
    AssignFile(destf, SaveDlg.FileName);
    Rewrite(destf);
    try
      Writeln(destf, ';Created by Phone Card Emulator v1.0, developed by Cyber, Peter Sladek <');
      Writeln(destf, ';for MP-LAB compiler (using EQU directive)');
      Writeln(destf, ';NOTE:');
      case reading of
        LSB: begin
               Writeln(destf, ';bit 0 as LSB - byte reading:');
               Writeln(destf, ';bit out: 0-> 1-> 2-> 3-> 4-> 5-> 6-> 7 ->8 ->9... bit-reading sequence');
               Writeln(destf, ';bit #:   0   1   2   3   4   5   6   7   0   1');
             end;
        MSB: begin
               Writeln(destf, ';bit 0 as MSB - byte reading:');
               Writeln(destf, ';bit out: 0-> 1-> 2-> 3-> 4-> 5-> 6-> 7 ->8 ->9... bit-reading sequence');
               Writeln(destf, ';bit #:   7   6   5   4   3   2   1   0   7   6');
             end;
      end;
      Writeln(destf,'');
      Writeln(destf,'');
      for i:= 0 to $0B do begin
        case mp_lab_style of
          syByte: Writeln(destf, 'B' + IntToHex(i, 2)+ #9 + #9 + 'equ' + #9 + IntToHex(dummy[i], 3)+ 'h');
          syBit: Writeln(destf, 'bs' + IntToStr(i*8) + '_' + IntToStr((i*8)+7)+ #9 + #9 + 'equ' + #9 + IntToHex(dummy[i], 3)+ 'h');
        end;
      end;
      Writeln(destf, '');
    finally
      CloseFile(destf);
    end;
  end;

end;

procedure TPhoneForm.saveMPLABbitsClick(Sender: TObject);
begin
  mp_lab_style:= syBit;
  saveMPLABbyteClick(self);
end;

procedure TPhoneForm.saveBinary1Click(Sender: TObject);
begin
  if SaveDlg.Execute then
    BinaryForm.BinMem.Lines.SaveToFile(SaveDlg.Filename);
end;

procedure TPhoneForm.WriteBit;
begin
  {-null-}
  Write_RTS(false);
  Write_DTR(false);
  Write_TxD(true);
  Wait; Wait;
  Write_DTR(true);
  Wait; Wait;
  Write_RTS(true);
  Wait; Wait; Wait;
  Wait; Wait; Wait;
  Write_RTS(false); {clk}
  Write_DTR(false); {-r/w}
  Wait; Wait; Wait;
  Wait;
  Write_DTR(true);
  Wait;
  Write_RTS(true);
  Wait; Wait; Wait;
  Wait; Wait; Wait;
  Write_DTR(false);
  Wait;
  Write_RTS(false);
end;

procedure TPhoneForm.SetCardPtr;
var i: byte;
begin
  CardReset;
  for i:=0 to $60 do begin
      {CLK___---____}
      Write_RTS(false);
      Wait;
      Write_RTS(true);
      Wait;
      Wait;
      Write_RTS(false);
      Wait;
  end;
  while Scan_DSR(PBA) or (i=$FF) do begin
      inc(i);
      {CLK___---____}
      Write_RTS(false);
      Wait;
      Write_RTS(true);
      Wait;
      Wait;
      Write_RTS(false);
      Wait;
  end;
end;

procedure TPhoneForm.DeleteUnit;
begin
  if not u_pos then
    SetCardPtr;
  WriteBit;
  u_pos:= true;
end;

procedure TPhoneForm.DeletePosition(p: byte);
var i: byte;
begin
  for i:=1 to p do begin
      {CLK___---____}
      Write_RTS(false);
      Wait;
      Write_RTS(true);
      Wait;
      Wait;
      Write_RTS(false);
      Wait;
  end;
  WriteBit;
end;

procedure TPhoneForm.Delete_autoClick(Sender: TObject);
begin
  DeleteUnit;
end;

procedure TPhoneForm.Deleteposition1Click(Sender: TObject);
var value: string;
begin
  if InputQuery('Delete unit at position','Insert bit address (starting with 0) [DEC] not [HEX]!', value) then
    DeletePosition(StrToInt(value));
end;

procedure TPhoneForm.WriteBtnClick(Sender: TObject);
begin
  del_unit_pop.popup(writebtn.left +10+ phoneform.left ,writeBtn.top+20+ phoneform.top);
end;

end.

